// WARNING: DO NOT EDIT. This file was generated by a program.
// See $MOJO_SDK/tools/bindings/mojom_bindings_generator.py.

library surfaces_mojom;
import 'dart:async';
import 'package:mojo/bindings.dart' as bindings;
import 'package:mojo/core.dart' as core;
import 'package:mojo/mojo/bindings/types/service_describer.mojom.dart' as service_describer;
import 'package:mojo_services/mojo/geometry.mojom.dart' as geometry_mojom;
import 'package:mojo_services/mojo/quads.mojom.dart' as quads_mojom;

class ResourceFormat extends bindings.MojoEnum {
  static const ResourceFormat rgba8888 = const ResourceFormat._(0);
  static const ResourceFormat rgba4444 = const ResourceFormat._(1);
  static const ResourceFormat bgra8888 = const ResourceFormat._(2);
  static const ResourceFormat alpha8 = const ResourceFormat._(3);
  static const ResourceFormat luminance8 = const ResourceFormat._(4);
  static const ResourceFormat rgb565 = const ResourceFormat._(5);
  static const ResourceFormat etc1 = const ResourceFormat._(6);

  const ResourceFormat._(int v) : super(v);

  static const Map<String, ResourceFormat> valuesMap = const {
    "rgba8888": rgba8888,
    "rgba4444": rgba4444,
    "bgra8888": bgra8888,
    "alpha8": alpha8,
    "luminance8": luminance8,
    "rgb565": rgb565,
    "etc1": etc1,
  };
  static const List<ResourceFormat> values = const [
    rgba8888,
    rgba4444,
    bgra8888,
    alpha8,
    luminance8,
    rgb565,
    etc1,
  ];

  static ResourceFormat valueOf(String name) => valuesMap[name];

  factory ResourceFormat(int v) {
    switch (v) {
      case 0:
        return ResourceFormat.rgba8888;
      case 1:
        return ResourceFormat.rgba4444;
      case 2:
        return ResourceFormat.bgra8888;
      case 3:
        return ResourceFormat.alpha8;
      case 4:
        return ResourceFormat.luminance8;
      case 5:
        return ResourceFormat.rgb565;
      case 6:
        return ResourceFormat.etc1;
      default:
        return null;
    }
  }

  static ResourceFormat decode(bindings.Decoder decoder0, int offset) {
    int v = decoder0.decodeUint32(offset);
    ResourceFormat result = new ResourceFormat(v);
    if (result == null) {
      throw new bindings.MojoCodecError(
          'Bad value $v for enum ResourceFormat.');
    }
    return result;
  }

  String toString() {
    switch(this) {
      case rgba8888:
        return 'ResourceFormat.rgba8888';
      case rgba4444:
        return 'ResourceFormat.rgba4444';
      case bgra8888:
        return 'ResourceFormat.bgra8888';
      case alpha8:
        return 'ResourceFormat.alpha8';
      case luminance8:
        return 'ResourceFormat.luminance8';
      case rgb565:
        return 'ResourceFormat.rgb565';
      case etc1:
        return 'ResourceFormat.etc1';
      default:
        return null;
    }
  }

  int toJson() => mojoEnumValue;
}



class Mailbox extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  List<int> name = null;

  Mailbox() : super(kVersions.last.size);

  Mailbox.init(
    List<int> this.name
  ) : super(kVersions.last.size);

  static Mailbox deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static Mailbox decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    Mailbox result = new Mailbox();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.name = decoder0.decodeInt8Array(8, bindings.kNothingNullable, 64);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "Mailbox";
    String fieldName;
    try {
      fieldName = "name";
      encoder0.encodeInt8Array(name, 8, bindings.kNothingNullable, 64);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "Mailbox("
           "name: $name" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["name"] = name;
    return map;
  }
}


class MailboxHolder extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  Mailbox mailbox = null;
  int textureTarget = 0;
  int syncPoint = 0;

  MailboxHolder() : super(kVersions.last.size);

  MailboxHolder.init(
    Mailbox this.mailbox, 
    int this.textureTarget, 
    int this.syncPoint
  ) : super(kVersions.last.size);

  static MailboxHolder deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static MailboxHolder decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    MailboxHolder result = new MailboxHolder();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(8, false);
      result.mailbox = Mailbox.decode(decoder1);
    }
    if (mainDataHeader.version >= 0) {
      
      result.textureTarget = decoder0.decodeUint32(16);
    }
    if (mainDataHeader.version >= 0) {
      
      result.syncPoint = decoder0.decodeUint32(20);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "MailboxHolder";
    String fieldName;
    try {
      fieldName = "mailbox";
      encoder0.encodeStruct(mailbox, 8, false);
      fieldName = "textureTarget";
      encoder0.encodeUint32(textureTarget, 16);
      fieldName = "syncPoint";
      encoder0.encodeUint32(syncPoint, 20);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "MailboxHolder("
           "mailbox: $mailbox" ", "
           "textureTarget: $textureTarget" ", "
           "syncPoint: $syncPoint" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["mailbox"] = mailbox;
    map["textureTarget"] = textureTarget;
    map["syncPoint"] = syncPoint;
    return map;
  }
}


class TransferableResource extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(40, 0)
  ];
  int id = 0;
  ResourceFormat format = null;
  int filter = 0;
  bool isRepeated = false;
  bool isSoftware = false;
  geometry_mojom.Size size = null;
  MailboxHolder mailboxHolder = null;

  TransferableResource() : super(kVersions.last.size);

  TransferableResource.init(
    int this.id, 
    ResourceFormat this.format, 
    int this.filter, 
    bool this.isRepeated, 
    bool this.isSoftware, 
    geometry_mojom.Size this.size, 
    MailboxHolder this.mailboxHolder
  ) : super(kVersions.last.size);

  static TransferableResource deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static TransferableResource decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    TransferableResource result = new TransferableResource();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.id = decoder0.decodeUint32(8);
    }
    if (mainDataHeader.version >= 0) {
      
        result.format = ResourceFormat.decode(decoder0, 12);
        if (result.format == null) {
          throw new bindings.MojoCodecError(
            'Trying to decode null union for non-nullable ResourceFormat.');
        }
    }
    if (mainDataHeader.version >= 0) {
      
      result.filter = decoder0.decodeUint32(16);
    }
    if (mainDataHeader.version >= 0) {
      
      result.isRepeated = decoder0.decodeBool(20, 0);
    }
    if (mainDataHeader.version >= 0) {
      
      result.isSoftware = decoder0.decodeBool(20, 1);
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(24, false);
      result.size = geometry_mojom.Size.decode(decoder1);
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(32, false);
      result.mailboxHolder = MailboxHolder.decode(decoder1);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "TransferableResource";
    String fieldName;
    try {
      fieldName = "id";
      encoder0.encodeUint32(id, 8);
      fieldName = "format";
      encoder0.encodeEnum(format, 12);
      fieldName = "filter";
      encoder0.encodeUint32(filter, 16);
      fieldName = "isRepeated";
      encoder0.encodeBool(isRepeated, 20, 0);
      fieldName = "isSoftware";
      encoder0.encodeBool(isSoftware, 20, 1);
      fieldName = "size";
      encoder0.encodeStruct(size, 24, false);
      fieldName = "mailboxHolder";
      encoder0.encodeStruct(mailboxHolder, 32, false);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "TransferableResource("
           "id: $id" ", "
           "format: $format" ", "
           "filter: $filter" ", "
           "isRepeated: $isRepeated" ", "
           "isSoftware: $isSoftware" ", "
           "size: $size" ", "
           "mailboxHolder: $mailboxHolder" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["id"] = id;
    map["format"] = format;
    map["filter"] = filter;
    map["isRepeated"] = isRepeated;
    map["isSoftware"] = isSoftware;
    map["size"] = size;
    map["mailboxHolder"] = mailboxHolder;
    return map;
  }
}


class ReturnedResource extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  int id = 0;
  int syncPoint = 0;
  int count = 0;
  bool lost = false;

  ReturnedResource() : super(kVersions.last.size);

  ReturnedResource.init(
    int this.id, 
    int this.syncPoint, 
    int this.count, 
    bool this.lost
  ) : super(kVersions.last.size);

  static ReturnedResource deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static ReturnedResource decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    ReturnedResource result = new ReturnedResource();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.id = decoder0.decodeUint32(8);
    }
    if (mainDataHeader.version >= 0) {
      
      result.syncPoint = decoder0.decodeUint32(12);
    }
    if (mainDataHeader.version >= 0) {
      
      result.count = decoder0.decodeInt32(16);
    }
    if (mainDataHeader.version >= 0) {
      
      result.lost = decoder0.decodeBool(20, 0);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "ReturnedResource";
    String fieldName;
    try {
      fieldName = "id";
      encoder0.encodeUint32(id, 8);
      fieldName = "syncPoint";
      encoder0.encodeUint32(syncPoint, 12);
      fieldName = "count";
      encoder0.encodeInt32(count, 16);
      fieldName = "lost";
      encoder0.encodeBool(lost, 20, 0);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "ReturnedResource("
           "id: $id" ", "
           "syncPoint: $syncPoint" ", "
           "count: $count" ", "
           "lost: $lost" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["id"] = id;
    map["syncPoint"] = syncPoint;
    map["count"] = count;
    map["lost"] = lost;
    return map;
  }
}


class Frame extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  List<TransferableResource> resources = null;
  List<quads_mojom.Pass> passes = null;

  Frame() : super(kVersions.last.size);

  Frame.init(
    List<TransferableResource> this.resources, 
    List<quads_mojom.Pass> this.passes
  ) : super(kVersions.last.size);

  static Frame deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static Frame decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    Frame result = new Frame();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(8, false);
      {
        var si1 = decoder1.decodeDataHeaderForPointerArray(bindings.kUnspecifiedArrayLength);
        result.resources = new List<TransferableResource>(si1.numElements);
        for (int i1 = 0; i1 < si1.numElements; ++i1) {
          
          var decoder2 = decoder1.decodePointer(bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i1, false);
          result.resources[i1] = TransferableResource.decode(decoder2);
        }
      }
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(16, false);
      {
        var si1 = decoder1.decodeDataHeaderForPointerArray(bindings.kUnspecifiedArrayLength);
        result.passes = new List<quads_mojom.Pass>(si1.numElements);
        for (int i1 = 0; i1 < si1.numElements; ++i1) {
          
          var decoder2 = decoder1.decodePointer(bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i1, false);
          result.passes[i1] = quads_mojom.Pass.decode(decoder2);
        }
      }
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "Frame";
    String fieldName;
    try {
      fieldName = "resources";
      if (resources == null) {
        encoder0.encodeNullPointer(8, false);
      } else {
        var encoder1 = encoder0.encodePointerArray(resources.length, 8, bindings.kUnspecifiedArrayLength);
        for (int i0 = 0; i0 < resources.length; ++i0) {
          encoder1.encodeStruct(resources[i0], bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i0, false);
        }
      }
      fieldName = "passes";
      if (passes == null) {
        encoder0.encodeNullPointer(16, false);
      } else {
        var encoder1 = encoder0.encodePointerArray(passes.length, 16, bindings.kUnspecifiedArrayLength);
        for (int i0 = 0; i0 < passes.length; ++i0) {
          encoder1.encodeStruct(passes[i0], bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i0, false);
        }
      }
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "Frame("
           "resources: $resources" ", "
           "passes: $passes" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["resources"] = resources;
    map["passes"] = passes;
    return map;
  }
}


class _ResourceReturnerReturnResourcesParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  List<ReturnedResource> resources = null;

  _ResourceReturnerReturnResourcesParams() : super(kVersions.last.size);

  _ResourceReturnerReturnResourcesParams.init(
    List<ReturnedResource> this.resources
  ) : super(kVersions.last.size);

  static _ResourceReturnerReturnResourcesParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static _ResourceReturnerReturnResourcesParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _ResourceReturnerReturnResourcesParams result = new _ResourceReturnerReturnResourcesParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(8, false);
      {
        var si1 = decoder1.decodeDataHeaderForPointerArray(bindings.kUnspecifiedArrayLength);
        result.resources = new List<ReturnedResource>(si1.numElements);
        for (int i1 = 0; i1 < si1.numElements; ++i1) {
          
          var decoder2 = decoder1.decodePointer(bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i1, false);
          result.resources[i1] = ReturnedResource.decode(decoder2);
        }
      }
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "_ResourceReturnerReturnResourcesParams";
    String fieldName;
    try {
      fieldName = "resources";
      if (resources == null) {
        encoder0.encodeNullPointer(8, false);
      } else {
        var encoder1 = encoder0.encodePointerArray(resources.length, 8, bindings.kUnspecifiedArrayLength);
        for (int i0 = 0; i0 < resources.length; ++i0) {
          encoder1.encodeStruct(resources[i0], bindings.ArrayDataHeader.kHeaderSize + bindings.kPointerSize * i0, false);
        }
      }
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "_ResourceReturnerReturnResourcesParams("
           "resources: $resources" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["resources"] = resources;
    return map;
  }
}


class _SurfaceGetIdNamespaceParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(8, 0)
  ];

  _SurfaceGetIdNamespaceParams() : super(kVersions.last.size);

  _SurfaceGetIdNamespaceParams.init(
  ) : super(kVersions.last.size);

  static _SurfaceGetIdNamespaceParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static _SurfaceGetIdNamespaceParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _SurfaceGetIdNamespaceParams result = new _SurfaceGetIdNamespaceParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    return result;
  }

  void encode(bindings.Encoder encoder) {
    encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "_SurfaceGetIdNamespaceParams";
    String fieldName;
    try {
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "_SurfaceGetIdNamespaceParams("")";
  }

  Map toJson() {
    Map map = new Map();
    return map;
  }
}


class SurfaceGetIdNamespaceResponseParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  int idNamespace = 0;

  SurfaceGetIdNamespaceResponseParams() : super(kVersions.last.size);

  SurfaceGetIdNamespaceResponseParams.init(
    int this.idNamespace
  ) : super(kVersions.last.size);

  static SurfaceGetIdNamespaceResponseParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static SurfaceGetIdNamespaceResponseParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    SurfaceGetIdNamespaceResponseParams result = new SurfaceGetIdNamespaceResponseParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.idNamespace = decoder0.decodeUint32(8);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "SurfaceGetIdNamespaceResponseParams";
    String fieldName;
    try {
      fieldName = "idNamespace";
      encoder0.encodeUint32(idNamespace, 8);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "SurfaceGetIdNamespaceResponseParams("
           "idNamespace: $idNamespace" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["idNamespace"] = idNamespace;
    return map;
  }
}


class _SurfaceSetResourceReturnerParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  ResourceReturnerInterface returner = null;

  _SurfaceSetResourceReturnerParams() : super(kVersions.last.size);

  _SurfaceSetResourceReturnerParams.init(
    ResourceReturnerInterface this.returner
  ) : super(kVersions.last.size);

  static _SurfaceSetResourceReturnerParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static _SurfaceSetResourceReturnerParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _SurfaceSetResourceReturnerParams result = new _SurfaceSetResourceReturnerParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.returner = decoder0.decodeServiceInterface(8, false, ResourceReturnerProxy.newFromEndpoint);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "_SurfaceSetResourceReturnerParams";
    String fieldName;
    try {
      fieldName = "returner";
      encoder0.encodeInterface(returner, 8, false);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "_SurfaceSetResourceReturnerParams("
           "returner: $returner" ")";
  }

  Map toJson() {
    throw new bindings.MojoCodecError(
        'Object containing handles cannot be encoded to JSON.');
  }
}


class _SurfaceCreateSurfaceParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  int idLocal = 0;

  _SurfaceCreateSurfaceParams() : super(kVersions.last.size);

  _SurfaceCreateSurfaceParams.init(
    int this.idLocal
  ) : super(kVersions.last.size);

  static _SurfaceCreateSurfaceParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static _SurfaceCreateSurfaceParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _SurfaceCreateSurfaceParams result = new _SurfaceCreateSurfaceParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.idLocal = decoder0.decodeUint32(8);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "_SurfaceCreateSurfaceParams";
    String fieldName;
    try {
      fieldName = "idLocal";
      encoder0.encodeUint32(idLocal, 8);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "_SurfaceCreateSurfaceParams("
           "idLocal: $idLocal" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["idLocal"] = idLocal;
    return map;
  }
}


class _SurfaceSubmitFrameParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(24, 0)
  ];
  int idLocal = 0;
  Frame frame = null;

  _SurfaceSubmitFrameParams() : super(kVersions.last.size);

  _SurfaceSubmitFrameParams.init(
    int this.idLocal, 
    Frame this.frame
  ) : super(kVersions.last.size);

  static _SurfaceSubmitFrameParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static _SurfaceSubmitFrameParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _SurfaceSubmitFrameParams result = new _SurfaceSubmitFrameParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.idLocal = decoder0.decodeUint32(8);
    }
    if (mainDataHeader.version >= 0) {
      
      var decoder1 = decoder0.decodePointer(16, false);
      result.frame = Frame.decode(decoder1);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "_SurfaceSubmitFrameParams";
    String fieldName;
    try {
      fieldName = "idLocal";
      encoder0.encodeUint32(idLocal, 8);
      fieldName = "frame";
      encoder0.encodeStruct(frame, 16, false);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "_SurfaceSubmitFrameParams("
           "idLocal: $idLocal" ", "
           "frame: $frame" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["idLocal"] = idLocal;
    map["frame"] = frame;
    return map;
  }
}


class SurfaceSubmitFrameResponseParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(8, 0)
  ];

  SurfaceSubmitFrameResponseParams() : super(kVersions.last.size);

  SurfaceSubmitFrameResponseParams.init(
  ) : super(kVersions.last.size);

  static SurfaceSubmitFrameResponseParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static SurfaceSubmitFrameResponseParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    SurfaceSubmitFrameResponseParams result = new SurfaceSubmitFrameResponseParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    return result;
  }

  void encode(bindings.Encoder encoder) {
    encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "SurfaceSubmitFrameResponseParams";
    String fieldName;
    try {
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "SurfaceSubmitFrameResponseParams("")";
  }

  Map toJson() {
    Map map = new Map();
    return map;
  }
}


class _SurfaceDestroySurfaceParams extends bindings.Struct {
  static const List<bindings.StructDataHeader> kVersions = const [
    const bindings.StructDataHeader(16, 0)
  ];
  int idLocal = 0;

  _SurfaceDestroySurfaceParams() : super(kVersions.last.size);

  _SurfaceDestroySurfaceParams.init(
    int this.idLocal
  ) : super(kVersions.last.size);

  static _SurfaceDestroySurfaceParams deserialize(bindings.Message message) =>
      bindings.Struct.deserialize(decode, message);

  static _SurfaceDestroySurfaceParams decode(bindings.Decoder decoder0) {
    if (decoder0 == null) {
      return null;
    }
    _SurfaceDestroySurfaceParams result = new _SurfaceDestroySurfaceParams();

    var mainDataHeader = bindings.Struct.checkVersion(decoder0, kVersions);
    if (mainDataHeader.version >= 0) {
      
      result.idLocal = decoder0.decodeUint32(8);
    }
    return result;
  }

  void encode(bindings.Encoder encoder) {
    var encoder0 = encoder.getStructEncoderAtOffset(kVersions.last);
    const String structName = "_SurfaceDestroySurfaceParams";
    String fieldName;
    try {
      fieldName = "idLocal";
      encoder0.encodeUint32(idLocal, 8);
    } on bindings.MojoCodecError catch(e) {
      bindings.Struct.fixErrorMessage(e, fieldName, structName);
      rethrow;
    }
  }

  String toString() {
    return "_SurfaceDestroySurfaceParams("
           "idLocal: $idLocal" ")";
  }

  Map toJson() {
    Map map = new Map();
    map["idLocal"] = idLocal;
    return map;
  }
}

const int _resourceReturnerMethodReturnResourcesName = 0;

class _ResourceReturnerServiceDescription implements service_describer.ServiceDescription {
  void getTopLevelInterface(Function responder) {
    responder(null);
  }

  void getTypeDefinition(String typeKey, Function responder) {
    responder(null);
  }

  void getAllTypeDefinitions(Function responder) {
    responder(null);
  }
}

abstract class ResourceReturner {
  static const String serviceName = null;

  static service_describer.ServiceDescription _cachedServiceDescription;
  static service_describer.ServiceDescription get serviceDescription {
    if (_cachedServiceDescription == null) {
      _cachedServiceDescription = new _ResourceReturnerServiceDescription();
    }
    return _cachedServiceDescription;
  }

  static ResourceReturnerProxy connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    ResourceReturnerProxy p = new ResourceReturnerProxy.unbound();
    String name = serviceName ?? ResourceReturner.serviceName;
    if ((name == null) || name.isEmpty) {
      throw new core.MojoApiError(
          "If an interface has no ServiceName, then one must be provided.");
    }
    s.connectToService(url, p, name);
    return p;
  }
  void returnResources(List<ReturnedResource> resources);
}

abstract class ResourceReturnerInterface
    implements bindings.MojoInterface<ResourceReturner>,
               ResourceReturner {
  factory ResourceReturnerInterface([ResourceReturner impl]) =>
      new ResourceReturnerStub.unbound(impl);

  factory ResourceReturnerInterface.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint,
      [ResourceReturner impl]) =>
      new ResourceReturnerStub.fromEndpoint(endpoint, impl);

  factory ResourceReturnerInterface.fromMock(
      ResourceReturner mock) =>
      new ResourceReturnerProxy.fromMock(mock);
}

abstract class ResourceReturnerInterfaceRequest
    implements bindings.MojoInterface<ResourceReturner>,
               ResourceReturner {
  factory ResourceReturnerInterfaceRequest() =>
      new ResourceReturnerProxy.unbound();
}

class _ResourceReturnerProxyControl
    extends bindings.ProxyMessageHandler
    implements bindings.ProxyControl<ResourceReturner> {
  ResourceReturner impl;

  _ResourceReturnerProxyControl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _ResourceReturnerProxyControl.fromHandle(
      core.MojoHandle handle) : super.fromHandle(handle);

  _ResourceReturnerProxyControl.unbound() : super.unbound();

  String get serviceName => ResourceReturner.serviceName;

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  @override
  String toString() {
    var superString = super.toString();
    return "_ResourceReturnerProxyControl($superString)";
  }
}

class ResourceReturnerProxy
    extends bindings.Proxy<ResourceReturner>
    implements ResourceReturner,
               ResourceReturnerInterface,
               ResourceReturnerInterfaceRequest {
  ResourceReturnerProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint)
      : super(new _ResourceReturnerProxyControl.fromEndpoint(endpoint));

  ResourceReturnerProxy.fromHandle(core.MojoHandle handle)
      : super(new _ResourceReturnerProxyControl.fromHandle(handle));

  ResourceReturnerProxy.unbound()
      : super(new _ResourceReturnerProxyControl.unbound());

  factory ResourceReturnerProxy.fromMock(ResourceReturner mock) {
    ResourceReturnerProxy newMockedProxy =
        new ResourceReturnerProxy.unbound();
    newMockedProxy.impl = mock;
    return newMockedProxy;
  }

  static ResourceReturnerProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For ResourceReturnerProxy"));
    return new ResourceReturnerProxy.fromEndpoint(endpoint);
  }


  void returnResources(List<ReturnedResource> resources) {
    if (impl != null) {
      impl.returnResources(resources);
      return;
    }
    if (!ctrl.isBound) {
      ctrl.proxyError("The Proxy is closed.");
      return;
    }
    var params = new _ResourceReturnerReturnResourcesParams();
    params.resources = resources;
    ctrl.sendMessage(params,
        _resourceReturnerMethodReturnResourcesName);
  }
}

class _ResourceReturnerStubControl
    extends bindings.StubMessageHandler
    implements bindings.StubControl<ResourceReturner> {
  ResourceReturner _impl;

  _ResourceReturnerStubControl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [ResourceReturner impl])
      : super.fromEndpoint(endpoint, autoBegin: impl != null) {
    _impl = impl;
  }

  _ResourceReturnerStubControl.fromHandle(
      core.MojoHandle handle, [ResourceReturner impl])
      : super.fromHandle(handle, autoBegin: impl != null) {
    _impl = impl;
  }

  _ResourceReturnerStubControl.unbound([this._impl]) : super.unbound();

  String get serviceName => ResourceReturner.serviceName;



  void handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      bindings.ControlMessageHandler.handleMessage(
          this, 0, message);
      return;
    }
    if (_impl == null) {
      throw new core.MojoApiError("$this has no implementation set");
    }
    switch (message.header.type) {
      case _resourceReturnerMethodReturnResourcesName:
        var params = _ResourceReturnerReturnResourcesParams.deserialize(
            message.payload);
        _impl.returnResources(params.resources);
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
  }

  ResourceReturner get impl => _impl;
  set impl(ResourceReturner d) {
    if (d == null) {
      throw new core.MojoApiError("$this: Cannot set a null implementation");
    }
    if (isBound && (_impl == null)) {
      beginHandlingEvents();
    }
    _impl = d;
  }

  @override
  void bind(core.MojoMessagePipeEndpoint endpoint) {
    super.bind(endpoint);
    if (!isOpen && (_impl != null)) {
      beginHandlingEvents();
    }
  }

  @override
  String toString() {
    var superString = super.toString();
    return "_ResourceReturnerStubControl($superString)";
  }

  int get version => 0;
}

class ResourceReturnerStub
    extends bindings.Stub<ResourceReturner>
    implements ResourceReturner,
               ResourceReturnerInterface,
               ResourceReturnerInterfaceRequest {
  ResourceReturnerStub.unbound([ResourceReturner impl])
      : super(new _ResourceReturnerStubControl.unbound(impl));

  ResourceReturnerStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [ResourceReturner impl])
      : super(new _ResourceReturnerStubControl.fromEndpoint(endpoint, impl));

  ResourceReturnerStub.fromHandle(
      core.MojoHandle handle, [ResourceReturner impl])
      : super(new _ResourceReturnerStubControl.fromHandle(handle, impl));

  static ResourceReturnerStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For ResourceReturnerStub"));
    return new ResourceReturnerStub.fromEndpoint(endpoint);
  }


  void returnResources(List<ReturnedResource> resources) {
    return impl.returnResources(resources);
  }
}

const int _surfaceMethodGetIdNamespaceName = 0;
const int _surfaceMethodSetResourceReturnerName = 1;
const int _surfaceMethodCreateSurfaceName = 2;
const int _surfaceMethodSubmitFrameName = 3;
const int _surfaceMethodDestroySurfaceName = 4;

class _SurfaceServiceDescription implements service_describer.ServiceDescription {
  void getTopLevelInterface(Function responder) {
    responder(null);
  }

  void getTypeDefinition(String typeKey, Function responder) {
    responder(null);
  }

  void getAllTypeDefinitions(Function responder) {
    responder(null);
  }
}

abstract class Surface {
  static const String serviceName = "mojo::Surface";

  static service_describer.ServiceDescription _cachedServiceDescription;
  static service_describer.ServiceDescription get serviceDescription {
    if (_cachedServiceDescription == null) {
      _cachedServiceDescription = new _SurfaceServiceDescription();
    }
    return _cachedServiceDescription;
  }

  static SurfaceProxy connectToService(
      bindings.ServiceConnector s, String url, [String serviceName]) {
    SurfaceProxy p = new SurfaceProxy.unbound();
    String name = serviceName ?? Surface.serviceName;
    if ((name == null) || name.isEmpty) {
      throw new core.MojoApiError(
          "If an interface has no ServiceName, then one must be provided.");
    }
    s.connectToService(url, p, name);
    return p;
  }
  void getIdNamespace(void callback(int idNamespace));
  void setResourceReturner(ResourceReturnerInterface returner);
  void createSurface(int idLocal);
  void submitFrame(int idLocal,Frame frame,void callback());
  void destroySurface(int idLocal);
}

abstract class SurfaceInterface
    implements bindings.MojoInterface<Surface>,
               Surface {
  factory SurfaceInterface([Surface impl]) =>
      new SurfaceStub.unbound(impl);

  factory SurfaceInterface.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint,
      [Surface impl]) =>
      new SurfaceStub.fromEndpoint(endpoint, impl);

  factory SurfaceInterface.fromMock(
      Surface mock) =>
      new SurfaceProxy.fromMock(mock);
}

abstract class SurfaceInterfaceRequest
    implements bindings.MojoInterface<Surface>,
               Surface {
  factory SurfaceInterfaceRequest() =>
      new SurfaceProxy.unbound();
}

class _SurfaceProxyControl
    extends bindings.ProxyMessageHandler
    implements bindings.ProxyControl<Surface> {
  Surface impl;

  _SurfaceProxyControl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) : super.fromEndpoint(endpoint);

  _SurfaceProxyControl.fromHandle(
      core.MojoHandle handle) : super.fromHandle(handle);

  _SurfaceProxyControl.unbound() : super.unbound();

  String get serviceName => Surface.serviceName;

  void handleResponse(bindings.ServiceMessage message) {
    switch (message.header.type) {
      case _surfaceMethodGetIdNamespaceName:
        Function callback = getCallback(message);
        if (callback != null) {
          var r = SurfaceGetIdNamespaceResponseParams.deserialize(
              message.payload);
          callback(r.idNamespace );
        }
        break;
      case _surfaceMethodSubmitFrameName:
        Function callback = getCallback(message);
        if (callback != null) {
          var r = SurfaceSubmitFrameResponseParams.deserialize(
              message.payload);
          callback();
        }
        break;
      default:
        proxyError("Unexpected message type: ${message.header.type}");
        close(immediate: true);
        break;
    }
  }

  @override
  String toString() {
    var superString = super.toString();
    return "_SurfaceProxyControl($superString)";
  }
}

class SurfaceProxy
    extends bindings.Proxy<Surface>
    implements Surface,
               SurfaceInterface,
               SurfaceInterfaceRequest {
  SurfaceProxy.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint)
      : super(new _SurfaceProxyControl.fromEndpoint(endpoint));

  SurfaceProxy.fromHandle(core.MojoHandle handle)
      : super(new _SurfaceProxyControl.fromHandle(handle));

  SurfaceProxy.unbound()
      : super(new _SurfaceProxyControl.unbound());

  factory SurfaceProxy.fromMock(Surface mock) {
    SurfaceProxy newMockedProxy =
        new SurfaceProxy.unbound();
    newMockedProxy.impl = mock;
    return newMockedProxy;
  }

  static SurfaceProxy newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For SurfaceProxy"));
    return new SurfaceProxy.fromEndpoint(endpoint);
  }


  void getIdNamespace(void callback(int idNamespace)) {
    if (impl != null) {
      impl.getIdNamespace(callback ?? bindings.DoNothingFunction.fn);
      return;
    }
    var params = new _SurfaceGetIdNamespaceParams();
    Function zonedCallback;
    if ((callback == null) || identical(Zone.current, Zone.ROOT)) {
      zonedCallback = callback;
    } else {
      Zone z = Zone.current;
      zonedCallback = ((int idNamespace) {
        z.bindCallback(() {
          callback(idNamespace);
        })();
      });
    }
    ctrl.sendMessageWithRequestId(
        params,
        _surfaceMethodGetIdNamespaceName,
        -1,
        bindings.MessageHeader.kMessageExpectsResponse,
        zonedCallback);
  }
  void setResourceReturner(ResourceReturnerInterface returner) {
    if (impl != null) {
      impl.setResourceReturner(returner);
      return;
    }
    if (!ctrl.isBound) {
      ctrl.proxyError("The Proxy is closed.");
      return;
    }
    var params = new _SurfaceSetResourceReturnerParams();
    params.returner = returner;
    ctrl.sendMessage(params,
        _surfaceMethodSetResourceReturnerName);
  }
  void createSurface(int idLocal) {
    if (impl != null) {
      impl.createSurface(idLocal);
      return;
    }
    if (!ctrl.isBound) {
      ctrl.proxyError("The Proxy is closed.");
      return;
    }
    var params = new _SurfaceCreateSurfaceParams();
    params.idLocal = idLocal;
    ctrl.sendMessage(params,
        _surfaceMethodCreateSurfaceName);
  }
  void submitFrame(int idLocal,Frame frame,void callback()) {
    if (impl != null) {
      impl.submitFrame(idLocal,frame,callback ?? bindings.DoNothingFunction.fn);
      return;
    }
    var params = new _SurfaceSubmitFrameParams();
    params.idLocal = idLocal;
    params.frame = frame;
    Function zonedCallback;
    if ((callback == null) || identical(Zone.current, Zone.ROOT)) {
      zonedCallback = callback;
    } else {
      Zone z = Zone.current;
      zonedCallback = (() {
        z.bindCallback(() {
          callback();
        })();
      });
    }
    ctrl.sendMessageWithRequestId(
        params,
        _surfaceMethodSubmitFrameName,
        -1,
        bindings.MessageHeader.kMessageExpectsResponse,
        zonedCallback);
  }
  void destroySurface(int idLocal) {
    if (impl != null) {
      impl.destroySurface(idLocal);
      return;
    }
    if (!ctrl.isBound) {
      ctrl.proxyError("The Proxy is closed.");
      return;
    }
    var params = new _SurfaceDestroySurfaceParams();
    params.idLocal = idLocal;
    ctrl.sendMessage(params,
        _surfaceMethodDestroySurfaceName);
  }
}

class _SurfaceStubControl
    extends bindings.StubMessageHandler
    implements bindings.StubControl<Surface> {
  Surface _impl;

  _SurfaceStubControl.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [Surface impl])
      : super.fromEndpoint(endpoint, autoBegin: impl != null) {
    _impl = impl;
  }

  _SurfaceStubControl.fromHandle(
      core.MojoHandle handle, [Surface impl])
      : super.fromHandle(handle, autoBegin: impl != null) {
    _impl = impl;
  }

  _SurfaceStubControl.unbound([this._impl]) : super.unbound();

  String get serviceName => Surface.serviceName;


  Function _surfaceGetIdNamespaceResponseParamsResponder(
      int requestId) {
  return (int idNamespace) {
      var result = new SurfaceGetIdNamespaceResponseParams();
      result.idNamespace = idNamespace;
      sendResponse(buildResponseWithId(
          result,
          _surfaceMethodGetIdNamespaceName,
          requestId,
          bindings.MessageHeader.kMessageIsResponse));
    };
  }
  Function _surfaceSubmitFrameResponseParamsResponder(
      int requestId) {
  return () {
      var result = new SurfaceSubmitFrameResponseParams();
      sendResponse(buildResponseWithId(
          result,
          _surfaceMethodSubmitFrameName,
          requestId,
          bindings.MessageHeader.kMessageIsResponse));
    };
  }

  void handleMessage(bindings.ServiceMessage message) {
    if (bindings.ControlMessageHandler.isControlMessage(message)) {
      bindings.ControlMessageHandler.handleMessage(
          this, 0, message);
      return;
    }
    if (_impl == null) {
      throw new core.MojoApiError("$this has no implementation set");
    }
    switch (message.header.type) {
      case _surfaceMethodGetIdNamespaceName:
        _impl.getIdNamespace(_surfaceGetIdNamespaceResponseParamsResponder(message.header.requestId));
        break;
      case _surfaceMethodSetResourceReturnerName:
        var params = _SurfaceSetResourceReturnerParams.deserialize(
            message.payload);
        _impl.setResourceReturner(params.returner);
        break;
      case _surfaceMethodCreateSurfaceName:
        var params = _SurfaceCreateSurfaceParams.deserialize(
            message.payload);
        _impl.createSurface(params.idLocal);
        break;
      case _surfaceMethodSubmitFrameName:
        var params = _SurfaceSubmitFrameParams.deserialize(
            message.payload);
        _impl.submitFrame(params.idLocal, params.frame, _surfaceSubmitFrameResponseParamsResponder(message.header.requestId));
        break;
      case _surfaceMethodDestroySurfaceName:
        var params = _SurfaceDestroySurfaceParams.deserialize(
            message.payload);
        _impl.destroySurface(params.idLocal);
        break;
      default:
        throw new bindings.MojoCodecError("Unexpected message name");
        break;
    }
  }

  Surface get impl => _impl;
  set impl(Surface d) {
    if (d == null) {
      throw new core.MojoApiError("$this: Cannot set a null implementation");
    }
    if (isBound && (_impl == null)) {
      beginHandlingEvents();
    }
    _impl = d;
  }

  @override
  void bind(core.MojoMessagePipeEndpoint endpoint) {
    super.bind(endpoint);
    if (!isOpen && (_impl != null)) {
      beginHandlingEvents();
    }
  }

  @override
  String toString() {
    var superString = super.toString();
    return "_SurfaceStubControl($superString)";
  }

  int get version => 0;
}

class SurfaceStub
    extends bindings.Stub<Surface>
    implements Surface,
               SurfaceInterface,
               SurfaceInterfaceRequest {
  SurfaceStub.unbound([Surface impl])
      : super(new _SurfaceStubControl.unbound(impl));

  SurfaceStub.fromEndpoint(
      core.MojoMessagePipeEndpoint endpoint, [Surface impl])
      : super(new _SurfaceStubControl.fromEndpoint(endpoint, impl));

  SurfaceStub.fromHandle(
      core.MojoHandle handle, [Surface impl])
      : super(new _SurfaceStubControl.fromHandle(handle, impl));

  static SurfaceStub newFromEndpoint(
      core.MojoMessagePipeEndpoint endpoint) {
    assert(endpoint.setDescription("For SurfaceStub"));
    return new SurfaceStub.fromEndpoint(endpoint);
  }


  void getIdNamespace(void callback(int idNamespace)) {
    return impl.getIdNamespace(callback);
  }
  void setResourceReturner(ResourceReturnerInterface returner) {
    return impl.setResourceReturner(returner);
  }
  void createSurface(int idLocal) {
    return impl.createSurface(idLocal);
  }
  void submitFrame(int idLocal,Frame frame,void callback()) {
    return impl.submitFrame(idLocal,frame,callback);
  }
  void destroySurface(int idLocal) {
    return impl.destroySurface(idLocal);
  }
}



